--- old/usr/src/head/pthread.h	Sun Jul 27 18:01:20 2014
+++ new/usr/src/head/pthread.h	Sun Jul 27 18:01:20 2014
@@ -24,6 +24,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
+
 #ifndef _PTHREAD_H
 #define	_PTHREAD_H
 
@@ -183,8 +187,6 @@
 	__pthread_cleanup_pop(ex, &_cleanup_info); \
 }
 
-#ifdef	__STDC__
-
 /*
  * function prototypes - thread related calls
  */
@@ -205,9 +207,13 @@
 extern int pthread_attr_setstacksize(pthread_attr_t *, size_t);
 extern int pthread_attr_getstacksize(const pthread_attr_t *_RESTRICT_KYWD,
 		size_t *_RESTRICT_KYWD);
+
+#if !defined(_STRICT_SYMBOLS) && !defined(_XPG7)
 extern int pthread_attr_setstackaddr(pthread_attr_t *, void *);
 extern int pthread_attr_getstackaddr(const pthread_attr_t *_RESTRICT_KYWD,
 		void **_RESTRICT_KYWD);
+#endif
+
 extern int pthread_attr_setdetachstate(pthread_attr_t *, int);
 extern int pthread_attr_getdetachstate(const pthread_attr_t *, int *);
 extern int pthread_attr_setscope(pthread_attr_t *, int);
@@ -347,122 +353,6 @@
 extern int pthread_mutexattr_getrobust_np(
 	const pthread_mutexattr_t *_RESTRICT_KYWD, int *_RESTRICT_KYWD);
 
-#else	/* __STDC__ */
-
-/*
- * function prototypes - thread related calls
- */
-extern int pthread_atfork();
-extern int pthread_attr_init();
-extern int pthread_attr_destroy();
-extern int pthread_attr_setstack();
-extern int pthread_attr_getstack();
-extern int pthread_attr_setstacksize();
-extern int pthread_attr_getstacksize();
-extern int pthread_attr_setstackaddr();
-extern int pthread_attr_getstackaddr();
-extern int pthread_attr_setdetachstate();
-extern int pthread_attr_getdetachstate();
-extern int pthread_attr_setscope();
-extern int pthread_attr_getscope();
-extern int pthread_attr_setinheritsched();
-extern int pthread_attr_getinheritsched();
-extern int pthread_attr_setschedpolicy();
-extern int pthread_attr_getschedpolicy();
-extern int pthread_attr_setschedparam();
-extern int pthread_attr_getschedparam();
-extern int pthread_create();
-extern int pthread_once();
-extern int pthread_join();
-extern int pthread_detach();
-extern void pthread_exit();
-extern int pthread_cancel();
-extern int pthread_setschedparam();
-extern int pthread_getschedparam();
-extern int pthread_setschedprio();
-extern int pthread_setcancelstate();
-extern int pthread_setcanceltype();
-extern void pthread_testcancel();
-extern int pthread_equal();
-extern int pthread_key_create();
-extern int pthread_key_create_once_np();
-extern int pthread_key_delete();
-extern int pthread_setspecific();
-extern void *pthread_getspecific();
-extern pthread_t pthread_self();
-/*
- * function prototypes - synchronization related calls
- */
-extern int pthread_mutexattr_init();
-extern int pthread_mutexattr_destroy();
-extern int pthread_mutexattr_setpshared();
-extern int pthread_mutexattr_getpshared();
-extern int pthread_mutexattr_setprotocol();
-extern int pthread_mutexattr_getprotocol();
-extern int pthread_mutexattr_setprioceiling();
-extern int pthread_mutexattr_getprioceiling();
-extern int pthread_mutexattr_setrobust();
-extern int pthread_mutexattr_getrobust();
-extern int pthread_mutex_init();
-extern int pthread_mutex_consistent();
-extern int pthread_mutex_destroy();
-extern int pthread_mutex_lock();
-extern int pthread_mutex_timedlock();
-extern int pthread_mutex_reltimedlock_np();
-extern int pthread_mutex_unlock();
-extern int pthread_mutex_trylock();
-extern int pthread_mutex_setprioceiling();
-extern int pthread_mutex_getprioceiling();
-extern int pthread_condattr_init();
-extern int pthread_condattr_destroy();
-extern int pthread_condattr_setclock();
-extern int pthread_condattr_getclock();
-extern int pthread_condattr_setpshared();
-extern int pthread_condattr_getpshared();
-extern int pthread_cond_init();
-extern int pthread_cond_destroy();
-extern int pthread_cond_broadcast();
-extern int pthread_cond_signal();
-extern int pthread_cond_wait();
-extern int pthread_cond_timedwait();
-extern int pthread_cond_reltimedwait_np();
-extern int pthread_attr_getguardsize();
-extern int pthread_attr_setguardsize();
-extern int pthread_getconcurrency();
-extern int pthread_setconcurrency();
-extern int pthread_mutexattr_settype();
-extern int pthread_mutexattr_gettype();
-extern int pthread_rwlock_init();
-extern int pthread_rwlock_destroy();
-extern int pthread_rwlock_rdlock();
-extern int pthread_rwlock_tryrdlock();
-extern int pthread_rwlock_wrlock();
-extern int pthread_rwlock_trywrlock();
-extern int pthread_rwlock_unlock();
-extern int pthread_rwlockattr_init();
-extern int pthread_rwlockattr_destroy();
-extern int pthread_rwlockattr_getpshared();
-extern int pthread_rwlockattr_setpshared();
-extern int pthread_spin_init();
-extern int pthread_spin_destroy();
-extern int pthread_spin_lock();
-extern int pthread_spin_trylock();
-extern int pthread_spin_unlock();
-extern int pthread_barrierattr_init();
-extern int pthread_barrierattr_destroy();
-extern int pthread_barrierattr_setpshared();
-extern int pthread_barrierattr_getpshared();
-extern int pthread_barrier_init();
-extern int pthread_barrier_destroy();
-extern int pthread_barrier_wait();
-
-/* Historical names -- present only for binary compatibility */
-extern int pthread_mutex_consistent_np();
-extern int pthread_mutexattr_setrobust_np();
-extern int pthread_mutexattr_getrobust_np();
-
-#endif	/* __STDC__ */
-
 #endif	/* _ASM */
 
 #ifdef	__cplusplus
--- old/usr/src/head/signal.h	Sun Jul 27 18:01:20 2014
+++ new/usr/src/head/signal.h	Sun Jul 27 18:01:20 2014
@@ -31,8 +31,6 @@
 #ifndef _SIGNAL_H
 #define	_SIGNAL_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"	/* SVr4.0 1.5.3.4 */
-
 #include <sys/feature_tests.h>
 
 #if defined(__EXTENSIONS__) || !defined(_STRICT_STDC) || \
@@ -58,8 +56,6 @@
 #endif
 
 
-#if defined(__STDC__)
-
 extern const char	**_sys_siglistp;	/* signal descriptions */
 extern const int	_sys_siglistn;		/* # of signal descriptions */
 
@@ -98,9 +94,14 @@
 #define	SIG2STR_MAX	32
 #endif /* defined(__EXTENSIONS__) || (!defined(_STRICT_STDC)... */
 
-#if defined(__EXTENSIONS__) || (!defined(_STRICT_STDC) && \
-	!defined(__XOPEN_OR_POSIX)) || defined(_XPG4_2)
+/* Added in Issue 4 version 2, obsoleted in Issue 6 and removed in Issue 7 */
+#if (!defined(_STRICT_SYMBOLS)) || (defined(_XPG4_2) && !defined(_XPG7))
+/* bsd_signal removed from Issue 7 */
 extern void (*bsd_signal(int, void (*)(int)))(int);
+#endif
+
+/* Added in Issue 4 version 2 */
+#if (!defined(_STRICT_SYMBOLS)) || defined(_XPG4_2)
 extern int killpg(pid_t, int);
 extern int siginterrupt(int, int);
 extern int sigaltstack(const stack_t *_RESTRICT_KYWD, stack_t *_RESTRICT_KYWD);
@@ -109,12 +110,10 @@
 extern int sigpause(int);
 extern int sigrelse(int);
 extern void (*sigset(int, void (*)(int)))(int);
-#endif /* defined(__EXTENSIONS__) || (!defined(_STRICT_STDC) && ... */
+#endif
 
-/* Marked as LEGACY in SUSv2 and removed in SUSv3 */
-#if defined(__EXTENSIONS__) || \
-	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX)) || \
-	(defined(_XPG4_2) && !defined(_XPG6))
+/* Added in Issue 4 version 2, obsoleted in SUSv2 and removed in SUSv3 */
+#if (!defined(_STRICT_SYMBOLS)) || (defined(_XPG4_2) && !defined(_XPG6))
 extern int sigstack(struct sigstack *, struct sigstack *);
 #endif
 
@@ -132,76 +131,6 @@
 extern int sigqueue(pid_t, int, const union sigval);
 #endif /* defined(__EXTENSIONS__) || (!defined(_STRICT_STDC) && */
 
-#else	/* __STDC__ */
-
-extern char	**_sys_siglistp;	/* signal descriptions */
-extern int	_sys_siglistn;		/* # of signal descriptions */
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX)
-#define	_sys_siglist	_sys_siglistp
-#define	_sys_nsig	_sys_siglistn
-#endif
-
-#if defined(__EXTENSIONS__) || defined(__XOPEN_OR_POSIX)
-extern int kill();
-extern int sigaction();
-#ifndef	_KERNEL
-extern int sigaddset();
-extern int sigdelset();
-extern int sigemptyset();
-extern int sigfillset();
-extern int sigismember();
-#endif
-extern int sigpending();
-extern int sigprocmask();
-extern int sigsuspend();
-#endif /* defined(__EXTENSIONS__)... */
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || \
-	defined(_XPG4_2)
-extern void (*bsd_signal())();
-extern int killpg();
-extern int siginterrupt();
-#endif /* defined(__EXTENSIONS__) ... */
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || \
-	(defined(_XPG4_2) && !defined(_XPG6))
-extern int sigstack();
-#endif
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX)
-extern int gsignal();
-extern int (*ssignal)();
-extern int sigsend();
-extern int sigsendset();
-extern int sig2str();
-extern int str2sig();
-#define	SIG2STR_MAX	32
-#endif
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || \
-	defined(_XPG4_2)
-extern int sigaltstack();
-extern int sighold();
-extern int sigignore();
-extern int sigpause();
-extern int sigrelse();
-extern void (*sigset())();
-#endif
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || \
-	(_POSIX_C_SOURCE > 2)
-#include <sys/siginfo.h>
-#include <sys/time.h>
-extern int pthread_kill();
-extern int pthread_sigmask();
-extern int sigwaitinfo();
-extern int sigtimedwait();
-extern int sigqueue();
-#endif
-
-#endif	/* __STDC__ */
-
 /*
  * sigwait() prototype is defined here.
  */
@@ -210,8 +139,6 @@
 	!defined(__XOPEN_OR_POSIX)) || (_POSIX_C_SOURCE - 0 >= 199506L) || \
 	defined(_POSIX_PTHREAD_SEMANTICS)
 
-#if	defined(__STDC__)
-
 #if	(_POSIX_C_SOURCE - 0 >= 199506L) || defined(_POSIX_PTHREAD_SEMANTICS)
 
 #ifdef __PRAGMA_REDEFINE_EXTNAME
@@ -241,42 +168,6 @@
 
 #endif  /* (_POSIX_C_SOURCE - 0 >= 199506L) || ... */
 
-
-#else  /* __STDC__ */
-
-
-#if	(_POSIX_C_SOURCE - 0 >= 199506L) || defined(_POSIX_PTHREAD_SEMANTICS)
-
-#ifdef __PRAGMA_REDEFINE_EXTNAME
-#pragma redefine_extname sigwait __posix_sigwait
-extern int sigwait();
-#else  /* __PRAGMA_REDEFINE_EXTNAME */
-
-extern int __posix_sigwait();
-
-#ifdef	__lint
-#define	sigwait __posix_sigwait
-#else	/* !__lint */
-
-static int
-sigwait(__setp, __signo)
-	sigset_t *__setp;
-	int *__signo;
-{
-	return (__posix_sigwait(__setp, __signo));
-}
-
-#endif /* !__lint */
-#endif /* __PRAGMA_REDEFINE_EXTNAME */
-
-#else  /* (_POSIX_C_SOURCE - 0 >= 199506L) || ... */
-
-extern int sigwait();
-
-#endif /* (_POSIX_C_SOURCE - 0 >= 199506L) || ... */
-
-#endif /* __STDC__ */
-
 #endif /* defined(__EXTENSIONS__) || (!defined(_STRICT_STDC) ... */
 
 #ifdef	__cplusplus
--- old/usr/src/head/stdlib.h	Sun Jul 27 18:01:20 2014
+++ new/usr/src/head/stdlib.h	Sun Jul 27 18:01:20 2014
@@ -20,6 +20,7 @@
  */
 
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 2013 Gary Mills
  *
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
@@ -87,8 +88,6 @@
 typedef	unsigned int	uid_t;		/* UID type		*/
 #endif	/* !_UID_T */
 
-#if defined(__STDC__)
-
 /* large file compilation environment setup */
 #if !defined(_LP64) && _FILE_OFFSET_BITS == 64
 
@@ -179,13 +178,17 @@
 #endif
 #endif	/* _LARGEFILE64_SOURCE... */
 
+/* Added in XPG4.2, obsoleted in Issue 6, removed in Issue 7 */
+#if !defined(_STRICT_SYMBOLS) || (defined(_XPG4_2) && !defined(_XPG7))
+extern char *ecvt(double, int, int *_RESTRICT_KYWD, int *_RESTRICT_KYWD);
+extern char *fcvt(double, int, int *_RESTRICT_KYWD, int *_RESTRICT_KYWD);
+extern char *gcvt(double, int, char *);
+#endif
+
 #if defined(__EXTENSIONS__) || \
 	(!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX)) || \
 	defined(_XPG4_2)
 extern long a64l(const char *);
-extern char *ecvt(double, int, int *_RESTRICT_KYWD, int *_RESTRICT_KYWD);
-extern char *fcvt(double, int, int *_RESTRICT_KYWD, int *_RESTRICT_KYWD);
-extern char *gcvt(double, int, char *);
 extern int getsubopt(char **, char *const *, char **);
 extern int  grantpt(int);
 extern char *initstate(unsigned, char *, size_t);
@@ -261,128 +264,6 @@
 
 #endif /* defined(__EXTENSIONS__) || !defined(_STRICT_STDC) ... */
 
-#else /* not __STDC__ */
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || \
-	(_POSIX_C_SOURCE - 0 >= 199506L) || defined(_REENTRANT)
-extern int rand_r();
-#endif	/* defined(__EXTENSIONS__) || defined(_REENTRANT) ... */
-
-extern void _exithandle();
-
-#if defined(__EXTENSIONS__) || !defined(_POSIX_C_SOURCE) || defined(_XPG4)
-extern double drand48();
-extern double erand48();
-extern long jrand48();
-extern void lcong48();
-extern long lrand48();
-extern long mrand48();
-extern long nrand48();
-extern unsigned short *seed48();
-extern void srand48();
-extern int putenv();
-extern void setkey();
-#endif /* defined(__EXTENSIONS__) || !defined(_POSIX_C_SOURCE) ... */
-
-#if (defined(__EXTENSIONS__) || !defined(_POSIX_C_SOURCE)) && \
-	(!defined(_XOPEN_SOURCE) || (defined(_XPG3) && !defined(_XPG4)))
-extern void swab();
-#endif
-
-#if defined(__EXTENSIONS__) || \
-	!defined(__XOPEN_OR_POSIX) || defined(_XPG4_2) || \
-	(defined(_LARGEFILE_SOURCE) && _FILE_OFFSET_BITS == 64)
-extern int	mkstemp();
-#if !defined(_XPG4_2) || defined(__EXTENSIONS__)
-extern int	mkstemps();
-#endif
-#endif	/* defined(__EXTENSIONS__) ... */
-
-#if	defined(_LARGEFILE64_SOURCE) && !((_FILE_OFFSET_BITS == 64) && \
-	    !defined(__PRAGMA_REDEFINE_EXTNAME))
-extern int	mkstemp64();
-#if !defined(_XPG4_2) || defined(__EXTENSIONS__)
-extern int	mkstemps64();
-#endif
-#endif	/* _LARGEFILE64_SOURCE... */
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || defined(_XPG4_2)
-extern long a64l();
-extern char *ecvt();
-extern char *fcvt();
-extern char *gcvt();
-extern int getsubopt();
-extern int grantpt();
-extern char *initstate();
-extern char *l64a();
-extern char *mktemp();
-extern char *ptsname();
-extern long random();
-extern char *realpath();
-extern char *setstate();
-extern void srandom();
-/* Marked LEGACY in SUSv2 and removed in SUSv3 */
-#if !defined(_XPG6) || defined(__EXTENSIONS__)
-extern int ttyslot();
-extern void *valloc();
-#endif /* !defined(_XPG6) || defined(__EXTENSIONS__) */
-#endif /* defined(__EXTENSIONS__) || ... || defined(_XPG4_2) */
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) || defined(_XPG6)
-extern int posix_memalign();
-extern int posix_openpt();
-extern int setenv();
-extern int unsetenv();
-#endif
-
-#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX)
-extern char *canonicalize_file_name();
-extern int clearenv();
-extern void closefrom();
-extern int daemon();
-extern int dup2();
-extern int dup3();
-extern int fdwalk();
-extern char *qecvt();
-extern char *qfcvt();
-extern char *qgcvt();
-extern char *getcwd();
-extern char *getexecname();
-
-#ifndef	__GETLOGIN_DEFINED	/* Avoid duplicate in unistd.h */
-#define	__GETLOGIN_DEFINED
-#ifndef	__USE_LEGACY_LOGNAME__
-#ifdef	__PRAGMA_REDEFINE_EXTNAME
-#pragma	redefine_extname getlogin getloginx
-#else	/* __PRAGMA_REDEFINE_EXTNAME */
-extern char *getloginx();
-#define	getlogin	getloginx
-#endif	/* __PRAGMA_REDEFINE_EXTNAME */
-#endif	/* __USE_LEGACY_LOGNAME__ */
-extern char *getlogin();
-#endif	/* __GETLOGIN_DEFINED */
-
-extern int getopt();
-extern char *optarg;
-extern int optind, opterr, optopt;
-extern char *getpass();
-extern char *getpassphrase();
-extern int getpw();
-extern int isatty();
-extern void *memalign();
-extern char *ttyname();
-extern char *mkdtemp();
-extern char *getprogname();
-extern void setprogname();
-
-#if defined(_LONGLONG_TYPE)
-extern char *lltostr();
-extern char *ulltostr();
-#endif  /* defined(_LONGLONG_TYPE) */
-#endif	/* defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) ... */
-
-#endif	/* __STDC__ */
-
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/head/strings.h	Sun Jul 27 18:01:21 2014
+++ new/usr/src/head/strings.h	Sun Jul 27 18:01:21 2014
@@ -24,7 +24,7 @@
  * All rights reserved.
  */
 /*
- * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 #ifndef	_STRINGS_H
@@ -41,14 +41,14 @@
 extern "C" {
 #endif
 
-#if defined(__STDC__)
-
+/* These symbols were replaced with mem* in XPG7 */
+#if (!defined(_STRICT_SYMBOLS)) || (!defined(_XPG7))
 extern int bcmp(const void *, const void *, size_t);
 extern void bcopy(const void *, void *, size_t);
 extern void bzero(void *, size_t);
-
 extern char *index(const char *, int);
 extern char *rindex(const char *, int);
+#endif
 
 /*
  * X/Open System Interfaces and Headers, Issue 4, Version 2, defines
@@ -74,27 +74,6 @@
 #endif	/* defined(_XPG7) */
 #endif	/* defined(_XPG4_2) && !defined(__EXTENSIONS__) */
 
-#else
-
-extern int bcmp();
-extern void bcopy();
-extern void bzero();
-
-extern char *index();
-extern char *rindex();
-
-#if defined(_XPG4_2) && !defined(__EXTENSIONS__)
-extern int ffs();
-extern int strcasecmp();
-extern int strncasecmp();
-#if defined(_XPG7)
-extern int strcasecmp_l();
-extern int strncasecmp_l();
-#endif
-#endif /* defined(_XPG4_2) && !defined(__EXTENSIONS__) */
-
-#endif	/* __STDC__ */
-
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/head/ucontext.h	Sun Jul 27 18:01:21 2014
+++ new/usr/src/head/ucontext.h	Sun Jul 27 18:01:21 2014
@@ -26,6 +26,9 @@
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
 
 #ifndef _UCONTEXT_H
 #define	_UCONTEXT_H
@@ -40,6 +43,14 @@
 extern "C" {
 #endif
 
+/*
+ * Arguably, under _XPG7, applications should not even include this
+ * header, since it isn't part of Issue 7.  We apply some paranoia for
+ * the functions that were explicity removed, although we could likely
+ * just ignore the darn thing altogether.
+ */
+#if (!defined(_STRICT_SYMBOLS)) || (defined(_XPG4_2) && !defined(_XPG7))
+
 #ifdef __sparc
 #ifdef __PRAGMA_REDEFINE_EXTNAME
 #pragma	redefine_extname	makecontext	__makecontext_v2
@@ -48,8 +59,6 @@
 #endif
 #endif
 
-#if defined(__STDC__)
-
 extern int getcontext(ucontext_t *) __RETURNS_TWICE;
 #pragma unknown_control_flow(getcontext)
 extern int setcontext(const ucontext_t *) __NORETURN;
@@ -56,6 +65,8 @@
 extern int swapcontext(ucontext_t *_RESTRICT_KYWD,
 		const ucontext_t *_RESTRICT_KYWD);
 extern void makecontext(ucontext_t *, void(*)(), int, ...);
+#endif
+
 #if !defined(_XPG4_2) || defined(__EXTENSIONS__)
 extern int walkcontext(const ucontext_t *, int (*)(uintptr_t, int, void *),
     void *);
@@ -71,29 +82,7 @@
 
 extern void *_stack_grow(void *);
 #endif
-#else
 
-extern int getcontext() __RETURNS_TWICE;
-#pragma unknown_control_flow(getcontext)
-extern int setcontext();
-extern int swapcontext();
-extern void makecontext();
-#if !defined(_XPG4_2) || defined(__EXTENSIONS__)
-extern int walkcontext();
-extern int printstack();
-extern int addrtosymstr();
-extern int getustack();
-extern int setustack();
-
-extern int stack_getbounds();
-extern int stack_setbounds();
-extern int stack_inbounds();
-extern int stack_violation();
-
-extern void *_stack_grow();
-#endif
-#endif
-
 #ifdef	__cplusplus
 }
 #endif
